package com.abn.recipe.recipeservice.service;

import com.abn.recipe.recipeservice.dto.IngredientsDto;
import com.abn.recipe.recipeservice.dto.RecipeDto;
import com.abn.recipe.recipeservice.entity.Ingredients;
import com.abn.recipe.recipeservice.entity.Recipe;

import java.util.Set;

public abstract class AbstractEntityServiceTest {

    public static final Long INGREDIENT_ID_1001 = 1001L;
    public static final Long INGREDIENT_ID_1002 = 1002L;
    public static final Long INGREDIENT_ID_1003 = 1003L;
    public static final String INGREDIENT_NAME_1001 = "I-1001";
    public static final String INGREDIENT_NAME_1002 = "I-1002";
    public static final String INGREDIENT_NAME_1003 = "I-1003";

    public static final Long RECIPE_ID_1001 = 1001L;
    public static final Long RECIPE_ID_1002 = 1002L;
    public static final Long RECIPE_ID_1003 = 1003L;
    public static final String RECIPE_NAME_1001 = "R-1001";
    public static final String RECIPE_NAME_1002 = "R-1002";
    public static final String RECIPE_NAME_1003 = "R-1003";

    //Integration Test IDs - generated by DB Initialization Scripts
    public static final Long INGREDIENT_ID_5001 = 5001L;
    public static final Long INGREDIENT_ID_5002 = 5002L;
    public static final Long RECIPE_ID_6001 = 6001L;
    public static final Long RECIPE_ID_6002 = 6002L;
    public static final Long RECIPE_ID_6003 = 6003L;

    protected Recipe getRecipe(Long id, String name, boolean vegetarian, Long servingQuantity, Set<Ingredients> ingredients, String instructions) {
        return new Recipe(id, name, vegetarian, servingQuantity, ingredients, instructions);
    }

    protected RecipeDto getRecipeDto(Long id, String name, boolean vegetarian, Long servingQuantity, Set<IngredientsDto> ingredients, String instructions) {

        return RecipeDto.builder()
                .id(id)
                .name(name)
                .vegetarian(vegetarian)
                .servingQuantity(servingQuantity)
                .ingredients(ingredients)
                .instructions(instructions)
                .build();

    }

    protected Ingredients getIngredients(Long id, String name) {
        return new Ingredients(id, name);
    }

    protected IngredientsDto getIngredientsDto(Long id, String name) {
        return new IngredientsDto(id, name);
    }

}
